#pragma once
#include "NListCtrl.h"
#include "InfoSearchWnd.h"
#include "CallHistoryActorEvent.h"
#include "SkinDialog.h"
#include "SendMemoButtons.h"
#include "NMImgButton.h"

#define CH_DLG_MIN_X				500
#define CH_DLG_MIN_Y				520

#define CH_DLG_BTN_WIDTH			80
#define CH_DLG_BTN_HEIGHT			32
#define CH_DLG_BTN_GAP_X			4

#define CH_DLG_TYPE_BTN_WIDTH		90
#define CH_DLG_TYPE_BTN_HEIGHT		27
#define CH_DLG_TYPE_BTN_GAP_X		0

#define CH_DLG_COLUMN_STATUS		0
#define CH_DLG_COLUMN_DATETIME		1
#define CH_DLG_COLUMN_SENDER		2
#define CH_DLG_COLUMN_RECVER		3
#define CH_DLG_COLUMN_MEMO			4

#define CH_DLG_COLOR_STATIC_TEXT	(RGB(136, 136, 136))	// #888888
#define CH_DLG_COLOR_NAME_TEXT		(RGB(34, 34, 34))		// #222222
#define CH_DLG_COLOR_MEMO_BG1		(RGB(244, 245, 247))	// #f4f5f7

#define ID_CALL_HISTORY_SEARCH		(0xE200)


class CCallHistoryDlg : public CSkinDialog,
	public IOKCancelButtonsCallBack,
	private CAMSWnd,
	private CAMSWnd::PlacementHook
{
	//DECLARE_DYNAMIC(CCallHistoryDlg)

public:
	CCallHistoryDlg(CWnd* pParent = NULL);   // ǥ Դϴ.
	virtual ~CCallHistoryDlg();

	enum { IDD = IDD_CALL_HISTORY_DIALOG };

	void SetCallHistoryData(const std::vector<NE_CALL_DATA> &callData);
	void UpdateMemo(int nCallSeq);

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV Դϴ.
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	virtual BOOL OnInitDialog();
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnGetMinMaxInfo(MINMAXINFO* lpMMI);
	afx_msg void OnPaint();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnLvnItemchangedListCall(NMHDR *pNMHDR, LRESULT *pResult);
	void OnBnClickedBtnMemo();
	afx_msg int	 OnCreate(LPCREATESTRUCT lpCreateStruct);
	DECLARE_MESSAGE_MAP()

	virtual void OnButtonClicked(COKCancelButtons::BUTTONS button);

	void DoSearch(CString strSearchText);
	void __ResourceLoad(BOOL bInit);
	void InitList(CNListCtrl &list, CStringArray &strHeaderTitle);
	void ResizeListColumn(CNListCtrl &list, const int *arrWidth);
	void SetSkin();
	void ReSizeCtrl(void);
	bool IsCloseMsg(MSG* pMsg);
	void DeleteCallHistoryDataAll();
private:
	CNeMessengerDlg *m_pParentDlg;	// θâ ( θâ ˷־ deleteϱ )
	CCallHistoryActorEvent *m_pActorEvent;

	int m_nBorderHeight;
	int m_nBorderWidth;

	CString m_strSearchText;		// ˻
	UINT _clipBoardFormat;
	//int m_nHitTest;
	CBitmap	 m_bmTopBg;
	CPen m_penBorder;

	CImageList		m_ImageList;
	CNListCtrl m_lcCallHistory;		// ȭ Ʈ Ʈ
	CInfoSearchWnd	m_wndSearch;	// ˻â

	COKCancelButtons	*m_pOKCancelButtons;

	CEdit m_editMemo;
public:
	void OnBnClickedBtnClose();
	CNMImgButton m_btnTypeAll;
	CNMImgButton m_btnTypeSend;
	CNMImgButton m_btnTypeRecv;
	CNMImgButton m_btnTypeAbsent;

	CRect m_rtMemo;
	afx_msg void OnBnClickedBtnCallTypeAll();
	afx_msg void OnBnClickedBtnCallTypeSend();
	afx_msg void OnBnClickedBtnCallTypeRecv();
	afx_msg void OnBnClickedBtnCallTypeAbsent();
	CString GetMemo(CString strMemoFileName);
	CString MakeMemoFileName(CTime time, CString strRecvNm);
	bool SaveMemo(CString strMemoFileName, CString strHeader, CString strMemo);
	CNMImgComboBox m_cbSearchType;
	afx_msg void OnDestroy();
};
